#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>
#include <sdktools_entinput>
#include <cstrike>

public Plugin:myinfo = 
{
	name	= "Simple DeathMatch",
	author	= "wS / Schmidt",
	version	= "1.2",
	url		= "http://world-source.ru/"
};

new Handle:sd_spawn_sec;
new Handle:sd_spawn_protect_sec;
new Handle:sd_spawn_hp;
new Handle:sd_remove_weapons;
new Handle:g_RespawnTimer[MAXPLAYERS +1 ];
new Handle:g_ProtectTimer[MAXPLAYERS + 1];
new Handle:mp_ignore_round_win_conditions;

public OnPluginStart()
{
	mp_ignore_round_win_conditions	= FindConVar("mp_ignore_round_win_conditions");

	sd_spawn_sec					= CreateConVar("sd_spawn_sec", "2", "Через сколько секунд возродить игрока", _, true, 1.0);
	sd_spawn_protect_sec			= CreateConVar("sd_spawn_protect_sec", "2", "Сколько секунд защищать игрока после рождения", _, true, 1.0);
	sd_spawn_hp						= CreateConVar("sd_spawn_hp", "100", "Здоровье при рождении", _, true, 1.0);
	sd_remove_weapons				= CreateConVar("sd_remove_weapons", "1", "1 = удалять оружие убитого игрока; 0 = нет", _, true, 0.0, true, 1.0);

	AutoExecConfig(true,			"simple_deathmatch",	"sourcemod");

	HookEvent("player_death",		player_death);
	HookEvent("player_team",		player_team);
	HookEvent("player_hurt",		player_hurt);
	HookEvent("player_spawn",		player_spawn);
}

public OnConfigsExecuted()
{
	if (mp_ignore_round_win_conditions != INVALID_HANDLE) SetConVarInt(mp_ignore_round_win_conditions, 1);
}


///


public player_hurt(Handle:event, const String:name[], bool:silent)
{
	if (GetEventInt(event, "health") < 1 && GetConVarBool(sd_remove_weapons))
	{
		decl item, slot, client;
		client = GetClientOfUserId(GetEventInt(event, "userid"));
		for (slot = 0; slot < 4; slot++)
		{
			while ((item = GetPlayerWeaponSlot(client, slot)) > MaxClients)
			{
				if (RemovePlayerItem(client, item)) AcceptEntityInput(item, "Kill");
			}
		}
	}
}


///


public player_death(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	wS_KillTimerS(client);
	g_RespawnTimer[client] = CreateTimer(GetConVarFloat(sd_spawn_sec), g_RespawnTimer_CallBack, client, TIMER_REPEAT);
}

public Action:g_RespawnTimer_CallBack(Handle:timer, any:client)
{
	if (!IsClientInGame(client) || IsPlayerAlive(client))
	{
		g_RespawnTimer[client] = INVALID_HANDLE;
		return Plugin_Stop;
	}

	if (GetClientTeam(client) < 2)
		return Plugin_Continue;

	g_RespawnTimer[client] = INVALID_HANDLE;
	CS_RespawnPlayer(client);

	return Plugin_Stop;
}

public OnClientDisconnect(client)
{
	wS_KillTimerS(client);
}

wS_KillTimerS(client)
{
	if (g_RespawnTimer[client] != INVALID_HANDLE)
	{
		KillTimer(g_RespawnTimer[client]);
		g_RespawnTimer[client] = INVALID_HANDLE;
	}
	if (g_ProtectTimer[client] != INVALID_HANDLE)
	{
		KillTimer(g_ProtectTimer[client]);
		g_ProtectTimer[client] = INVALID_HANDLE;
	}
}


///


public player_spawn(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	wS_KillTimerS(client);
	SetEntProp(client, Prop_Data, "m_takedamage", 0);
	g_ProtectTimer[client] = CreateTimer(GetConVarFloat(sd_spawn_protect_sec), g_ProtectTimer_CallBack, client);
	SetEntProp(client, Prop_Send, "m_iHealth", GetConVarInt(sd_spawn_hp));
}

public Action:g_ProtectTimer_CallBack(Handle:timer, any:client)
{
	g_ProtectTimer[client] = INVALID_HANDLE;
	if (IsClientInGame(client) && IsPlayerAlive(client)) SetEntProp(client, Prop_Data, "m_takedamage", 2);
	return Plugin_Stop;
}


///


public Action:CS_OnTerminateRound(&Float:delay, &CSRoundEndReason:reason) return Plugin_Handled;
public Action:CS_OnBuyCommand(client, const String:weapon[]) return Plugin_Handled;

public player_team(Handle:event, const String:name[], bool:silent)
{
	if (GetEventInt(event, "oldteam") < 2 && GetEventInt(event, "team") > 1)
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		wS_KillTimerS(client);
		g_RespawnTimer[client] = CreateTimer(GetConVarFloat(sd_spawn_sec), g_RespawnTimer_CallBack, client, TIMER_REPEAT);
	}
}